package com.iconplus.smartproc.model.entity;

import com.iconplus.smartproc.helper.base.BaseEntity;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.Type;

import javax.persistence.*;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table(name = "rks_daftar_isi")
public class RksDaftarIsi extends BaseEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;

    @Column(name = "rks_daftar_id")
    private Long rksDaftarId;

    @Column(name = "nomor")
    private String nomor;

    @Column(name = "parent_id")
    private Integer parentId;

    @Column(name = "title")
    private String title;

    @Column(name = "level")
    private Integer level;

    @Column(name = "urutan")
    private String urutan;

    @Column(name = "is_kontrak")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean isKontrak;

    @Column(name = "is_active")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean isActive;

    @Column(name = "is_delete")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean isDelete;

}
