package com.iconplus.smartproc.model.request;

import com.iconplus.smartproc.helper.base.BaseRequest;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.data.domain.Pageable;
import org.springframework.web.multipart.MultipartFile;

import java.math.BigDecimal;
import java.sql.Date;
import java.sql.Timestamp;
import java.util.List;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class DrpPengadaanRequest extends BaseRequest {

    private Long id;
    private Long drpId;
    private Integer tahun;
    private String nomor;
    private String namaPengadaan;
    private Long lokasiId;
    private String lokasi;
    private Long jenisPengadaanId;
    private String jenisPengadaan;
    private Long unitInisiatorId;
    private String unitInisiator;
    private BigDecimal pagu;
    private Long sumberDanaId;
    private String sumberDana;
    private Long supplyPositioningMatrixId;
    private String supplyPositioningMatrix;
    private Long metodePengadaanId;
    private String metodePengadaan;
    private Long metodePenyampaianId;
    private String metodePenyampaian;
    private Long jenisKontrakId;
    private String jenisKontrak;
    private Long strategiPengadaanId;
    private String strategiPengadaan;
    private Date rencanaTanggal;
    private Date targetTanggal;
    private BigDecimal hpe;
    private Boolean isActive;
    private Boolean isDelete;

    private List<DrpPengadaanDokumenRequest> dataDrpPengadaanDokumen;

    private transient Pageable pageable;

    private MultipartFile file;

}
