package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.entity.RksDaftar;
import com.iconplus.smartproc.model.projection.RksDaftarIsiView;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.Optional;

@Repository
public interface RksDaftarRepository extends JpaRepository<RksDaftar, Long> {

    @Query(value = "SELECT rd.id as id, " +
            "rd.kodeTemplate as kodeTemplate, " +
            "rd.namaTemplate as namaTemplate, " +
            "rd.metodePengadaanId as metodePengadaanId, " +
            "mp.metodePengadaan as metodePengadaan " +
            "FROM RksDaftar rd " +
            "JOIN MetodePengadaan mp ON mp.id = rd.metodePengadaanId " +
            "WHERE rd.isDelete = false " +
            "ORDER BY rd.kodeTemplate")
    Page<RksDaftarIsiView> getListRksDaftarIsi(Pageable pageable);

    Optional<RksDaftar> findByKodeTemplateAndIsDeleteFalse(String kodeTemplate);

    Optional<RksDaftar> findByIdAndIsDeleteFalse(Long id);

}
