package com.iconplus.smartproc.service.rksdaftarisi;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.RksDaftarIsiRequest;
import com.iconplus.smartproc.repository.RksDaftarIsiRepository;
import com.iconplus.smartproc.util.Constants;
import org.springframework.stereotype.Service;

@Service
public class DeleteRksIsiService implements BaseService<RksDaftarIsiRequest, EmptyResponse> {

    private final RksDaftarIsiRepository rksDaftarIsiRepository;
    public DeleteRksIsiService(RksDaftarIsiRepository rksDaftarIsiRepository) {
        this.rksDaftarIsiRepository = rksDaftarIsiRepository;
    }

    @Override
    public EmptyResponse execute(RksDaftarIsiRequest input) {

        var rksIsi = rksDaftarIsiRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException(
                        Constants.ERR_CODE_10001,
                        Constants.ERR_TTL_10001,
                        String.format(Constants.ERR_MSG_10001, "RKS Isi", input.getId())
                ));

        rksIsi.setIsDelete(true);
        rksDaftarIsiRepository.save(rksIsi);
        return new EmptyResponse();
    }
}
