package com.iconplus.smartproc.service.rksdaftarisi;

import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.entity.RksDaftarIsi;
import com.iconplus.smartproc.model.request.RksDaftarIsiRequest;
import com.iconplus.smartproc.model.response.RksDaftarIsiResponse;
import com.iconplus.smartproc.repository.RksDaftarIsiRepository;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.stereotype.Service;

@Service
public class PostCreateRksIsiService implements BaseService<RksDaftarIsiRequest, RksDaftarIsiResponse> {

    private final RksDaftarIsiRepository rksDaftarIsiRepository;
    public PostCreateRksIsiService(RksDaftarIsiRepository rksDaftarIsiRepository) {
        this.rksDaftarIsiRepository = rksDaftarIsiRepository;
    }

    @Override
    public RksDaftarIsiResponse execute(RksDaftarIsiRequest input) {

        RksDaftarIsi rksDaftarIsi = RksDaftarIsi.builder()
                .rksDaftarId(input.getRksDaftarId())
                .nomor(input.getNomor())
                .parentId(ObjectUtils.isEmpty(input.getParentId()) ? 0 : input.getParentId())
                .title(input.getTitle())
                .level(input.getLevel())
                .urutan(input.getUrutan())
                .isKontrak(input.getIsKontrak())
                .isActive(input.getIsActive())
                .isDelete(false)
                .build();

        var result = rksDaftarIsiRepository.save(rksDaftarIsi);

        return RksDaftarIsiResponse.builder()
                .id(result.getId())
                .build();
    }
}
