package com.iconplus.smartproc.service.rksdaftarisi;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.RksDaftarIsiRequest;
import com.iconplus.smartproc.model.response.RksDaftarIsiResponse;
import com.iconplus.smartproc.repository.RksDaftarIsiRepository;
import com.iconplus.smartproc.util.Constants;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.stereotype.Service;

@Service
public class PutEditRksIsiService implements BaseService<RksDaftarIsiRequest, RksDaftarIsiResponse> {

    private final RksDaftarIsiRepository rksDaftarIsiRepository;
    public PutEditRksIsiService(RksDaftarIsiRepository rksDaftarIsiRepository) {
        this.rksDaftarIsiRepository = rksDaftarIsiRepository;
    }

    @Override
    public RksDaftarIsiResponse execute(RksDaftarIsiRequest input) {

        var rksIsi = rksDaftarIsiRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException(
                        Constants.ERR_CODE_10001,
                        Constants.ERR_TTL_10001,
                        String.format(Constants.ERR_MSG_10001, "RKS Isi", input.getId())
                ));

        rksIsi.setTitle(input.getTitle());
        rksIsi.setUrutan(input.getUrutan());
        rksIsi.setIsKontrak(input.getIsKontrak());
        rksIsi.setIsActive(ObjectUtils.isEmpty(input.getIsActive()) ? rksIsi.getIsActive() : input.getIsActive());
        rksDaftarIsiRepository.save(rksIsi);

        return RksDaftarIsiResponse.builder()
                .id(rksIsi.getId())
                .build();
    }
}
