package com.iconplus.smartproc.service.rkstemplate;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.RksTemplateVariabelRequest;
import com.iconplus.smartproc.repository.RksTemplateVariabelRepository;
import com.iconplus.smartproc.util.Constants;
import org.springframework.stereotype.Service;

@Service
public class DeleteRksTemplateVariabelService implements BaseService<RksTemplateVariabelRequest, EmptyResponse> {

    private final RksTemplateVariabelRepository rksTemplateVariabelRepository;
    public DeleteRksTemplateVariabelService(RksTemplateVariabelRepository rksTemplateVariabelRepository) {
        this.rksTemplateVariabelRepository = rksTemplateVariabelRepository;
    }

    @Override
    public EmptyResponse execute(RksTemplateVariabelRequest input) {

        var rksTemplateVariabel = rksTemplateVariabelRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException(
                        Constants.ERR_CODE_10001,
                        Constants.ERR_TTL_10001,
                        String.format(Constants.ERR_MSG_10001, "RKS Template Variabel", input.getId())
                ));

        rksTemplateVariabel.setIsDelete(true);
        rksTemplateVariabelRepository.save(rksTemplateVariabel);

        return new EmptyResponse();
    }
}
